function [XI] = d2e_ypr(dcm, dosymbolic)

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

if (nargin < 2)
    dosymbolic = 1;
end
if (nargin < 1)
    syms y p r
    dcm = e2d_ypr([y p r]);
    dcm = transpose(e2d_rpy_inv_of_ypr([y p r]));
    dosymbolic = 1;
end

Q_11 = dcm(1,1);
Q_12 = dcm(1,2);
Q_21 = dcm(2,1);
Q_31 = dcm(3,1);
Q_13 = dcm(1,3);
Q_23 = dcm(2,3);
Q_32 = dcm(3,2);
Q_33 = dcm(3,3);

% make PHI,THE & PSI
if (~dosymbolic)
    PSI=atan2(Q_12,Q_11);
    THE=-asin(Q_13);   
    PHI=atan2(Q_23,Q_33);  
else
    PSI=atan(Q_12/Q_11);
    THE=-asin(Q_13);   
    PHI=atan(Q_23/Q_33);  
end

XI = [PSI THE PHI];

if (nargin < 1)
    XI;
end
