function [dcm] = e2d_ypr(XI)

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

nice_graph = 0;
if (nargin < 1)
    XI =  [pi/2,   pi/6,  0 ];   % Any rotation
end


for (i=1:size(XI,1))
      phi = XI(i,3); the=XI(i,2); psi=XI(i,1); %add to check R matric ito psi the phi

    % Determine the rotational matrix about the 3 axes
    % Rotation about the Z axes

      CosPsi = cos(psi);
      SinPsi = sin(psi);
      Rz = [  CosPsi  SinPsi 0
              -SinPsi  CosPsi 0
               0          0   1];

    % Rotation about the Y axes
      CosThe = cos(the);
      SinThe = sin(the);
      Ry = [ CosThe  0  -SinThe
              0    1   0
             SinThe  0  CosThe];

    % Rotation about the X axes
      CosPhi = cos(phi);
      SinPhi = sin(phi);
      Rx = [ 1    0     0
             0   CosPhi SinPhi
             0   -SinPhi CosPhi];
         
      dcm(:,:,i) = Rx * Ry * Rz;
end
    
dcm = squeeze(dcm);

if (nargin == 0)
    scale_factor = 1;
    step = 30;
    cameratoolbar('Show');
    cameratoolbar('SetMode','orbit','SetCoordSys','none');
    h = figure(1);
    a1 = gca;
    axis equal; axis vis3d; 
    set(a1,'Visible','on');
    set(a1,'Color',[0 0 0]);
    view(0,0);
    if (nice_graph)
        %view(82.50,2);
        axis off;
    end
    
    % Initial scene render
    % Aircraft model        
    target = load('../../data/models/target_MirageF1.mat','-mat');
    
    R0=dcm;
    tv_tx = (target.model.V .* scale_factor)*R0;
    
    p=patch('faces', target.model.F, 'vertices' ,tv_tx);
    set(p, 'facec', [1 0 0]);          
    set(p, 'FaceVertexCData', target.model.R);  
    set(p, 'EdgeColor','none'); 
    
    xlabel('X (m)');
    ylabel('Y (m)');
    zlabel('Z (m)');
    light
    title('Testing YPR');
    drawnow;
end

