function dcm=q2d(q)
%Q2D Quaternion to Direction Cosine Matrix conversion
%	dcm=q2d(q) with:
%	dcm	Direction cosine matrix
%	q	Quaternion q=[q0,q1,q2,q3]'
%
% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

q0=q(1,1);
q1=q(1,2);
q2=q(1,3);
q3=q(1,4);

dcm=zeros(3);
dcm(1,1)=q0^2+q1^2-q2^2-q3^2;
dcm(2,1)=2*(q1*q2+q0*q3);
dcm(3,1)=2*(q1*q3-q0*q2);

dcm(1,2)=2*(q1*q2-q0*q3);
dcm(2,2)=q0^2-q1^2+q2^2-q3^2;
dcm(3,2)=2*(q2*q3+q0*q1);

dcm(1,3)=2*(q1*q3+q0*q2);
dcm(2,3)=2*(q2*q3-q0*q1);
dcm(3,3)=q0^2-q1^2-q2^2+q3^2;