function qq = qmul(q1, q2)

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

if nargin < 1
    q1 = [1;2;3;4];
    q2 = [1;2;3;4];
    syms q10 q11 q12 q13; 
    syms q20 q21 q22 q23;
    
    % Check the 2x2 representations multiply
    q1 = [q10;q11;q12;q13];
    q2 = [q20;q21;q22;q23];    
    Q1 = [ q1(1)+1i*q1(4)  q1(3)-1i*q1(2)
          -q1(3)-1i*q1(2)  q1(1)-1i*q1(4)];
    Q2 = [ q2(1)+1i*q2(4)  q2(3)-1i*q2(2)
          -q2(3)-1i*q2(2)  q2(1)-1i*q2(4)];
    simplify(Q1*Q2)
end

% Same as Toussaint's Introduction to Robotics - Eq 6    
qq = [  q1(1,:).*q2(1,:) - sum(q1(2:4,:).*q2(2:4,:));  
        q1(1,:).*q2(2:4,:) + q2(1,:).*q1(2:4,:) + cross(q1(2:4,:),q2(2:4,:),1) ];