function [ E ] = quat_dist( q1, qs )
%QUAT_DIST array of distances from q1 to each qs

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

Ts = repmat(q1,size(qs,1),1);
S = sum(Ts.*qs,2);
iS = S<0;
S(iS) = sum(-Ts(iS,:).*qs(iS,:),2);
E = acos(S);
