function [ n, the ] = rotd( dcm )
% rotate a vector x around n by an angle theta 
% this function calculates n and theta 
% See Zipfel for the formulae

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

if (nargin<1)
%%
    n0 = rand(3,1);
    n0 = n0/norm(n0);
    the0 = deg2rad(10);
    x = rand(3,1);
    [xx, dcm] = rotn (n0, x, the0);
    
    %%
    n1 = rand(3,1);
    n1 = n1/norm(n1);
    the1 = deg2rad(100);
    [xx, dcm0] = rotn (n0, x, the0);
    [xx, dcm1] = rotn (n1, x, the1);
    dcm  = dcm0(:,:)*dcm1(:,:);
    
    %%
    syms n11 n12 n13 n21 n22 n23 the1 the2
    [xx, dcm0] = rotn ([n11, n12, n13], x, the1);
    [xx, dcm1] = rotn ([n21, n22, n23], x, the2);
    dcm  = dcm0(:,:)*dcm1(:,:);
    
    %%
    dcm3 = [ (1-cos(the1))+cos(the1),           (1-cos(the1))-sin(the1)*n13, (1-cos(the1))+sin(the1)*n12;  ...
     (1-cos(the1))+sin(the1)*n13,       (1-cos(the1))+cos(the1),     (1-cos(the1))-sin(the1)*n11;   ...
     (1-cos(the1))-sin(the1)*n12,       (1-cos(the1))+sin(the1)*n11, (1-cos(the1))+cos(the1)        ];

    dcm4 = [  (1-cos(the2))+cos(the2),           (1-cos(the2))-sin(the2)*n23, (1-cos(the2))+sin(the2)*n22;  ...
     (1-cos(the2))+sin(the2)*n23,       (1-cos(the2))+cos(the2),      (1-cos(the2))-sin(the2)*n21;   ...
     (1-cos(the2))-sin(the2)*n22,       (1-cos(the2))+sin(the2)*n21,  (1-cos(the2))+cos(the2)       ]; 

    %%
    dcm = dcm3*dcm4
    
    
    
%%    
    
end

rr = diag(dcm);
the = acos(sum(0.5.*rr)-0.5);
n = 1./2./sin(the).*[dcm(3,2)-dcm(2,3); dcm(1,3)-dcm(3,1); dcm(2,1)-dcm(1,2)];

if (nargin<1)
    
    ttt = simple(the);
    nnn = simple(n);
    
    pretty (ttt);
    pretty (nnn);
    
    [ [the ; n], [the0 ; n0] ]
end


% dcm0 =
%  
% [                               (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1), (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2), (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2)]
% [ (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2),                               (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1), (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2)]
% [ (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2), (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2),                               (1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1)]
%  
%  
% dcm1
%  
% dcm1 =
%  
% [                               (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2), (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2), (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2)]
% [ (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2),                               (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2), (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2)]
% [ (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2), (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2),                               (1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2)]

% n =
%  
%  1/2/(1-(3/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))-1/2)^2)^(1/2)*(((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))+((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2)))
%  1/2/(1-(3/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))-1/2)^2)^(1/2)*(((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))+((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2)))
%  1/2/(1-(3/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))-1/2)^2)^(1/2)*(((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))+((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))-((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2)))

% the =
% 
% acos(3/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+cos(the1))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+cos(the2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n13/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n23/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))-sin(the1)*n12/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))+sin(the2)*n22/(n21^2+n22^2+n23^2)^(1/2))+1/2*((1-cos(the1))*(n11^2/(n11^2+n12^2+n13^2)+n12^2/(n11^2+n12^2+n13^2)+n13^2/(n11^2+n12^2+n13^2))+sin(the1)*n11/(n11^2+n12^2+n13^2)^(1/2))*((1-cos(the2))*(n21^2/(n21^2+n22^2+n23^2)+n22^2/(n21^2+n22^2+n23^2)+n23^2/(n21^2+n22^2+n23^2))-sin(the2)*n21/(n21^2+n22^2+n23^2)^(1/2))-1/2)



% Step 2
% dcm0 =
%  
% [ (1-cos(the1))+cos(the1),           (1-cos(the1))-sin(the1)*n13, (1-cos(the1))+sin(the1)*n12    ]
% [ (1-cos(the1))+sin(the1)*n13,       (1-cos(the1))+cos(the1),     (1-cos(the1))-sin(the1)*n11    ]
% [ (1-cos(the1))-sin(the1)*n12,       (1-cos(the1))+sin(the1)*n11, (1-cos(the1))+cos(the1)        ]
%  
%  
% dcm1
%  
% dcm1 =
%  
% [ (1-cos(the2))+cos(the2),           (1-cos(the2))-sin(the2)*n23), (1-cos(the2))+sin(the2)*n22   ]
% [ (1-cos(the2))+sin(the2)*n23,       (1-cos(the2))+cos(the2),      (1-cos(the2))-sin(the2)*n21   ]
% [ (1-cos(the2))-sin(the2)*n22,       (1-cos(the2))+sin(the2)*n21,  (1-cos(the2))+cos(the2)       ] 

% n =
%  
%  1/2/(1-(3/2*((1-cos(the1))+cos(the1))*((1-cos(the2))+cos(the2))+1/2*((1-cos(the1))-sin(the1)*n13^(1/2))*((1-cos(the2))+sin(the2)*n23^(1/2))+1/2*((1-cos(the1))+sin(the1)*n12^(1/2))*((1-cos(the2))-sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n13^(1/2))*((1-cos(the2))-sin(the2)*n23^(1/2))+1/2*((1-cos(the1))-sin(the1)*n11^(1/2))*((1-cos(the2))+sin(the2)*n21^(1/2))+1/2*((1-cos(the1))-sin(the1)*n12^(1/2))*((1-cos(the2))+sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n11^(1/2))*((1-cos(the2))-sin(the2)*n21^(1/2))-1/2)^2)^(1/2)*(((1-cos(the1))-sin(the1)*n12^(1/2))*((1-cos(the2))-sin(the2)*n23^(1/2))+((1-cos(the1))+sin(the1)*n11^(1/2))*((1-cos(the2))+cos(the2))+((1-cos(the1))+cos(the1))*((1-cos(the2))+sin(the2)*n21^(1/2))-((1-cos(the1))+sin(the1)*n13^(1/2))*((1-cos(the2))+sin(the2)*n22^(1/2))-((1-cos(the1))+cos(the1))*((1-cos(the2))-sin(the2)*n21^(1/2))-((1-cos(the1))-sin(the1)*n11^(1/2))*((1-cos(the2))+cos(the2)))
%  1/2/(1-(3/2*((1-cos(the1))+cos(the1))*((1-cos(the2))+cos(the2))+1/2*((1-cos(the1))-sin(the1)*n13^(1/2))*((1-cos(the2))+sin(the2)*n23^(1/2))+1/2*((1-cos(the1))+sin(the1)*n12^(1/2))*((1-cos(the2))-sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n13^(1/2))*((1-cos(the2))-sin(the2)*n23^(1/2))+1/2*((1-cos(the1))-sin(the1)*n11^(1/2))*((1-cos(the2))+sin(the2)*n21^(1/2))+1/2*((1-cos(the1))-sin(the1)*n12^(1/2))*((1-cos(the2))+sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n11^(1/2))*((1-cos(the2))-sin(the2)*n21^(1/2))-1/2)^2)^(1/2)*(((1-cos(the1))+cos(the1))*((1-cos(the2))+sin(the2)*n22^(1/2))+((1-cos(the1))-sin(the1)*n13^(1/2))*((1-cos(the2))-sin(the2)*n21^(1/2))+((1-cos(the1))+sin(the1)*n12^(1/2))*((1-cos(the2))+cos(the2))-((1-cos(the1))-sin(the1)*n12^(1/2))*((1-cos(the2))+cos(the2))-((1-cos(the1))+sin(the1)*n11^(1/2))*((1-cos(the2))+sin(the2)*n23^(1/2))-((1-cos(the1))+cos(the1))*((1-cos(the2))-sin(the2)*n22^(1/2)))
%  1/2/(1-(3/2*((1-cos(the1))+cos(the1))*((1-cos(the2))+cos(the2))+1/2*((1-cos(the1))-sin(the1)*n13^(1/2))*((1-cos(the2))+sin(the2)*n23^(1/2))+1/2*((1-cos(the1))+sin(the1)*n12^(1/2))*((1-cos(the2))-sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n13^(1/2))*((1-cos(the2))-sin(the2)*n23^(1/2))+1/2*((1-cos(the1))-sin(the1)*n11^(1/2))*((1-cos(the2))+sin(the2)*n21^(1/2))+1/2*((1-cos(the1))-sin(the1)*n12^(1/2))*((1-cos(the2))+sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n11^(1/2))*((1-cos(the2))-sin(the2)*n21^(1/2))-1/2)^2)^(1/2)*(((1-cos(the1))+sin(the1)*n13^(1/2))*((1-cos(the2))+cos(the2))+((1-cos(the1))+cos(the1))*((1-cos(the2))+sin(the2)*n23^(1/2))+((1-cos(the1))-sin(the1)*n11^(1/2))*((1-cos(the2))-sin(the2)*n22^(1/2))-((1-cos(the1))+cos(the1))*((1-cos(the2))-sin(the2)*n23^(1/2))-((1-cos(the1))-sin(the1)*n13^(1/2))*((1-cos(the2))+cos(the2))-((1-cos(the1))+sin(the1)*n12^(1/2))*((1-cos(the2))+sin(the2)*n21^(1/2)))

% the =
% 
% acos(3/2*((1-cos(the1))+cos(the1))*((1-cos(the2))+cos(the2))+1/2*((1-cos(the1))-sin(the1)*n13^(1/2))*((1-cos(the2))+sin(the2)*n23^(1/2))+1/2*((1-cos(the1))+sin(the1)*n12^(1/2))*((1-cos(the2))-sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n13^(1/2))*((1-cos(the2))-sin(the2)*n23^(1/2))+1/2*((1-cos(the1))-sin(the1)*n11^(1/2))*((1-cos(the2))+sin(the2)*n21^(1/2))+1/2*((1-cos(the1))-sin(the1)*n12^(1/2))*((1-cos(the2))+sin(the2)*n22^(1/2))+1/2*((1-cos(the1))+sin(the1)*n11^(1/2))*((1-cos(the2))-sin(the2)*n21^(1/2))-1/2)
%%
dcm3 = [ (1-cos(the1))+cos(the1),           (1-cos(the1))-sin(the1)*n13, (1-cos(the1))+sin(the1)*n12;  ...
 (1-cos(the1))+sin(the1)*n13,       (1-cos(the1))+cos(the1),     (1-cos(the1))-sin(the1)*n11;   ...
 (1-cos(the1))-sin(the1)*n12,       (1-cos(the1))+sin(the1)*n11, (1-cos(the1))+cos(the1)        ];

dcm4 = [  (1-cos(the2))+cos(the2),           (1-cos(the2))-sin(the2)*n23, (1-cos(the2))+sin(the2)*n22;  ...
 (1-cos(the2))+sin(the2)*n23,       (1-cos(the2))+cos(the2),      (1-cos(the2))-sin(the2)*n21;   ...
 (1-cos(the2))-sin(the2)*n22,       (1-cos(the2))+sin(the2)*n21,  (1-cos(the2))+cos(the2)       ]; 

%%
dcm3*dcm4

% [ 1+(1-cos(the1)-sin(the1)*n13)*(1-cos(the2)+sin(the2)*n23)+(1-cos(the1)+sin(the1)*n12)*(1-cos(the2)-sin(the2)*n22),         2-cos(the2)-sin(the2)*n23-cos(the1)-sin(the1)*n13+(1-cos(the1)+sin(the1)*n12)*(1-cos(the2)+sin(the2)*n21),         2-cos(the2)+sin(the2)*n22+(1-cos(the1)-sin(the1)*n13)*(1-cos(the2)-sin(the2)*n21)-cos(the1)+sin(the1)*n12]
% [         2-cos(the1)+sin(the1)*n13-cos(the2)+sin(the2)*n23+(1-cos(the1)-sin(the1)*n11)*(1-cos(the2)-sin(the2)*n22), (1-cos(the1)+sin(the1)*n13)*(1-cos(the2)-sin(the2)*n23)+1+(1-cos(the1)-sin(the1)*n11)*(1-cos(the2)+sin(the2)*n21),         (1-cos(the1)+sin(the1)*n13)*(1-cos(the2)+sin(the2)*n22)+2-cos(the2)-sin(the2)*n21-cos(the1)-sin(the1)*n11]
% [         2-cos(the1)-sin(the1)*n12+(1-cos(the1)+sin(the1)*n11)*(1-cos(the2)+sin(the2)*n23)-cos(the2)-sin(the2)*n22,         (1-cos(the1)-sin(the1)*n12)*(1-cos(the2)-sin(the2)*n23)+2-cos(the1)+sin(the1)*n11-cos(the2)+sin(the2)*n21, (1-cos(the1)-sin(the1)*n12)*(1-cos(the2)+sin(the2)*n22)+(1-cos(the1)+sin(the1)*n11)*(1-cos(the2)-sin(the2)*n21)+1]
 

