function [ xx dcm ] = rotn( n, x, the )
% rotate a vector x around n by an angle theta 

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke

if (nargin<1)
    n = rand(3,1);
    the = deg2rad(10);
    x = rand(3,1);
%     n = [1;0;0];
%     the = deg2rad(90);
%     x = [0;1;0];
end

xx = zeros(3,length(the),size(x,2));
n = n./sqrt(ssqr(n));
for(i=1:length(the))
    dcm(:,:,i) = (1-cos(the(i))).*(n*transpose(n)) + cos(the(i)).*eye(3) + sin(the(i)).*skew(n);
    for(j=1:size(x,2))
        xx(:,i,j) = dcm(:,:,i)*x(:,j);
    end
end

% if (nargin<1)
%     xxx = RotateOHM(n',x',the)';
%     xx-xxx
% end