function [ pout ] = rotq( q, p )

% Same as pnew = q*p*conj(q)
% from http://www.mathworks.com/help/aeroblks/quaternionrotation.html
% Same as Toussaint's Introduction to Robotics - Eq 8

% Copyright (C) 2013 - Pieter V. Reyneke, South Africa
%
% Open Source licence, use whereever you like but at own risk, keep this
% complete copyright notice in the code and please send me updates and 
% report errors to pieter.reyneke@gmail.com. Will give recognition, if
% requested, after any valid comment leading to an update was recieved. 
%
% Author: PV Reyneke


pout = repmat(p,[1 1 size(q,1)]);
if( size(q,2) == 4 && size(p,1) == 3 )
    for (i = 1:size(q,1))
        q0 = q(i,1); q1 = q(i,2); q2 = q(i,3); q3 = q(i,4); 
        R = [
                1 - 2*q2^2 - 2*q3^2,  2*(q1*q2+q0*q3),   2*(q1*q3-q0*q2)
                2*(q1*q2-q0*q3),  1 - 2*q1^2 - 2*q3^2,   2*(q2*q3+q0*q1)
                2*(q1*q3+q0*q2),    2*(q2*q3-q0*q1), 1 - 2*q1^2 - 2*q2^2
            ];
        pout(:,:,i) = R * p;
    end
    pout = squeeze(pout);
else
    error('The size resriction for rotq.m was not met.')
end

    

